<?php
if(isset($_POST['flpOrderId'])){
	// Callback to FraudLabs Pro API
	$flpData['key'] = $_POST['flpAPIKey'];
	$flpData['action'] = ($_POST['flpAction'] == 0) ? 'REJECT' : 'APPROVE';
	$flpData['id'] = $_POST['flpId'];
	$flpData['format'] = 'json';

	$queries = '';
	foreach($flpData as $key=>$value){
		$queries .= $key . '=' . urlencode($value) . '&';
	}

	$url = 'https://api.fraudlabspro.com/v1/order/feedback?' . rtrim($queries, '&');

	// Trying to connect FraudLabs Pro Web Service for 3 times
	for($i=0; $i<3; $i++){

	 if (!$response = connect_curl($url)) {
		$response = @file_get_contents($url);
	   // This doesn't work by default on many hosts since it's disabled, so it should be used as a last resort.
	 } 

		if(is_null($json = json_decode($response)) === FALSE){
			$db->Execute("update " . TABLE_ORDERS_FRAUDLABSPRO . " set flp_status='" . $flpData['action'] . "' where order_id = '" . (int)$_POST['flpOrderId'] . "'");
			break; // Get out from the FOR loop once attempt succeed
		}
	}
	zen_redirect(zen_href_link(FILENAME_ORDERS, zen_get_all_get_params(array('action')) . 'action=edit', 'NONSSL'));
}

if ( ($check_status->fields['orders_status'] != $status) || zen_not_null($comments)) {
	if($status == 2 || $status == 3){
		$flp_query = $db->Execute("select * from " . TABLE_ORDERS_FRAUDLABSPRO . " where order_id='" . $oID . "'");

		if($flp_query->fields['flp_status'] == 'REVIEW'){
			// Callback to FraudLabs Pro API
			$flpData['key'] = $_POST['flpAPIKey'];
			$flpData['action'] = 'APPROVE';
			$flpData['id'] = $_POST['flpId'];
			$flpData['format'] = 'json';

			$queries = '';
			foreach($flpData as $key=>$value){
				$queries .= $key . '=' . urlencode($value) . '&';
			}

			$url = 'https://api.fraudlabspro.com/v1/order/feedback?' . rtrim($queries, '&');

			// Trying to connect FraudLabs Pro Web Service for 3 times
			for($i=0; $i<3; $i++){

			 if (!$response = connect_curl($url)) {
				$response = @file_get_contents($url);
			   // This doesn't work by default on many hosts since it's disabled, so it should be used as a last resort.
			 } 

				if(is_null($json = json_decode($response)) === FALSE){
					$db->Execute("update " . TABLE_ORDERS_FRAUDLABSPRO . " set flp_status='APPROVE' where order_id = '" . $oID . "'");
					break; // Get out from the FOR loop once attempt succeed
				}
			}
		}
	}
}

// Function to connect to curl by retched 
// file_get_contents is disabled by default for "security reasons" on many servers.
// This fix gets around that and uses cURL to connect to the server instead.
// It functionally returns the same result.
function connect_curl ($url) {
	if (function_exists('curl_init')) {

	$ch = curl_init();

	// Now set some options (most are optional)
	curl_setopt($ch, CURLOPT_URL, $url);

	// Set a referer
	curl_setopt($ch, CURLOPT_REFERER, HTTP_SERVER);
 
	// Include header in result? (0 = yes, 1 = no)
	curl_setopt($ch, CURLOPT_HEADER, 0);
 
	// Should cURL return or print out the data? (true = return, false = print)
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
 
	// Timeout in seconds
	curl_setopt($ch, CURLOPT_TIMEOUT, 120);
 
	// Download the given URL, and return output
	$response = curl_exec($ch);	
 
	// Close the cURL resource, and free system resources
	curl_close($ch);
	
	return $response;
	} else { 
		return NULL; // If this fails, return nothing.
	}
}
?>